#include <stdio.h>
#include <netdb.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <netinet/in.h>
#include <sys/un.h>

#define SERV_ADDR  "/tmp/example1"

int *
recv_fds()
{
   struct msghdr msg;
   struct iovec iov[1];
   struct sockaddr_un servaddr;
   struct sockaddr_un client_addr;
   int sfd;
   int recfd;
   int *retval;
   int length;
   static int fd_array[2];

   /*
    *  Get a socket into the AF_UNIX domain.
    */

   if ((sfd = socket(AF_UNIX, SOCK_STREAM, 0)) < 0) {
      return((int *)0);
   }

   /*
    *  Fill in our address and bind to it.
    */

   bzero((char *)&servaddr, sizeof(servaddr));
   servaddr.sun_family = AF_UNIX;
   strcpy(servaddr.sun_path, SERV_ADDR);

   if (bind(sfd, (struct sockaddr *)&servaddr,
           strlen(SERV_ADDR) + sizeof(servaddr.sun_family)) < 0) {
      close(sfd);
      return((int *)0);
   }

   /*
    *  Set the socket up for listening, with a queue
    *  length of 1.
    */

   if (listen(sfd, 1) < 0) {
      close(sfd);
      unlink(SERV_ADDR);
      return((int *)0);
   }

   length = sizeof(client_addr);
   if ((recfd = accept(sfd,
        (struct sockaddr *)&client_addr, &length)) < 0) {
      close(sfd);
      unlink(SERV_ADDR);
      return((int *)0);
   }

   /*
    *  Now that we have accepted the connection, we
    *  can read the message that contains the file descriptors.
    */

   iov[0].iov_base = (char *)0;
   iov[0].iov_len  = 0;

   msg.msg_iov    = iov;
   msg.msg_iovlen = 1;

   msg.msg_name    = (caddr_t)0;
   msg.msg_namelen = 0;

   /*
    *  Fill the access rights with the file descriptors.
    */

   msg.msg_accrights    = (caddr_t)fd_array;
   msg.msg_accrightslen = sizeof(fd_array);

   if (recvmsg(recfd, &msg, 0) < 0) {
      retval = (int *)0;
   } else {
      retval = fd_array;
   }

   close(sfd);
   unlink(SERV_ADDR);
   return(retval);
}
